--- nagios-plugins-1.3.0-beta2/plugins/check_tcp.c.orig	Wed Jan  8 11:33:22 2003
+++ nagios-plugins-1.3.0-beta2/plugins/check_tcp.c	Thu Jan  9 10:40:41 2003
@@ -233,6 +233,7 @@
 		return STATE_CRITICAL;
 
 	if (server_send != NULL) {		/* Something to send? */
+		strunescape(server_send, server_send);
 		asprintf (&server_send, "%s\r\n", server_send);
 #ifdef HAVE_SSL
 		if (use_ssl)
--- nagios-plugins-1.3.0-beta2/plugins/utils.c.orig	Thu Jan  9 10:30:24 2003
+++ nagios-plugins-1.3.0-beta2/plugins/utils.c	Thu Jan  9 10:45:31 2003
@@ -52,6 +52,7 @@
 char *strnl (char *str);
 char *strpcpy (char *dest, const char *src, const char *str);
 char *strpcat (char *dest, const char *src, const char *str);
+char *strunescape (char *dest, const char *src);
 
 #define LABELLEN 63
 #define STRLEN 64
@@ -559,4 +560,41 @@
 	dest[len + l2] = '\0';
 
 	return dest;
+}
+
+/******************************************************************************
+ *
+ * Copy string from src to dest, automatically converting backslashed escape
+ * sequences into actual characters. Similar to the printf("%b", str) feature
+ * found in some (sadly not all) C libraries. 
+ *
+ * The src and dest pointers can be the same: the function will overwrite the
+ * string in place.
+ *
+ * TODO: if anybody cares, they can add the \0ddd escape sequence. I was only
+ * interested in \r and \n.
+ *
+ *****************************************************************************/
+
+char *
+strunescape(char *dest, const char *src)
+{
+	while (src && dest && (*dest = *src)) {
+		if (*src == '\\') {
+			switch (*++src) {
+				case '\\': *dest = '\\'; break;
+				case 'b':  *dest = '\b'; break;
+				case 'n':  *dest = '\n'; break;
+				case 'r':  *dest = '\r'; break;
+				case 'a':  *dest = '\a'; break;
+				case 't':  *dest = '\t'; break;
+				case 'v':  *dest = '\v'; break;
+				case 'f':  *dest = '\f'; break;
+				default:   *dest = *src; break;
+			}
+		}
+		dest++; src++;
+        }
+
+	return dest;
 }
